// ID_GLOB.H


#include <ctype.h>
#include <stdio.h>

#include "version.h"

#ifndef MAXLONG
#define MAXLONG         0x7FFFFFFFL
#endif
#define FP_OFF(fp)      ((unsigned short)(fp))
#define FP_SEG(fp)      ((unsigned short)((unsigned long)(fp) >> 16))
#define MK_FP(seg,ofs)  ((void*)(((unsigned long)(seg) << 16) | (unsigned)(ofs)))

//--------------------------------------------------------------------------

#ifdef JAPAN
#ifdef JAPDEMO
#include "FOREIGN\JAPAN\GFXV_WJ1.H"
#else
#include "FOREIGN\JAPAN\GFXV_WJ6.H"
#endif
#include "AUDIOWL6.H"
#include "MAPSWL6.H"
#else

#ifndef SPEAR

#ifdef UPLOAD
#include "gfxv_wl1.h"
#else
#include "gfxv_wl6.h"
#endif
#include "audiowl6.h"
#include "mapswl6.h"

#else

#ifndef SPEARDEMO
#include "gfxv_sod.h"
#include "audiosod.h"
#include "mapssod.h"
#else
#include "gfxv_sdm.h"
#include "audiosdm.h"
#include "mapssdm.h"
#endif

#endif
#endif
//-----------------


//
//	ID Engine
//	Types.h - Generic types, #defines, etc.
//	v1.0d1
//


typedef	enum { false, true } wbool;
typedef	unsigned char	byte;
typedef	unsigned short	word;
typedef	unsigned long	longword;
typedef	byte * 			Ptr;

typedef	struct
{
  int x, y;
} Point;

typedef	struct
{
  Point	ul,lr;
} Rect;

#define	nil	((void *)0)


#include "id_mm.h"
#include "id_pm.h"
#include "id_ca.h"
#include "id_vl.h"
#include "id_vh.h"
#include "id_in.h"
#include "id_sd.h"
#include "id_us.h"


// defined in user program
void Quit(char *error);

extern	byte		signon[];
#define	introscn	signon

//
// replacing refresh manager with custom routines
//

#define	PORTTILESWIDE		20	// all drawing takes place inside a
#define	PORTTILESHIGH		13	// non displayed port of this size

#define UPDATEWIDE			PORTTILESWIDE
#define UPDATEHIGH			PORTTILESHIGH

#define	MAXTICS				10
#define DEMOTICS			4

extern	unsigned short	mapwidth, mapheight, tics;

extern	byte		fontcolor,backcolor;

#define SETFONTCOLOR(f,b) fontcolor=f;backcolor=b;
