//
//	ID_PM.H
//	Header file for Id Engine's Page Manager
//

//	NOTE! PMPageSize must be >= 1024
#define	PMPageSize		4096

#define	PMThrashThreshold	1	// Number of page thrashes before panic mode
#define	PMUnThrashThreshold	5	// Number of non-thrashing frames before leaving panic mode

typedef	enum
{
	pml_Unlocked,
	pml_Locked
} PMLockType;

typedef	enum
{
	pmba_Unused = 0,
	pmba_Used = 1,
	pmba_Allocated = 2
} PMBlockAttr;

typedef	struct
{
	longword	offset;		// Offset of chunk into file
	word		length;		// Length of the chunk

	PMLockType	locked;		// If set, this page can't be purged
	int			mainPage;	// If in Main, index into handle array

	longword	lastHit;	// Last frame number of hit
} PageListStruct;

extern	word			ChunksInFile,
						PMSpriteStart,PMSoundStart;
extern	PageListStruct	*PMPages;

#define	PM_GetSoundPage(v)	PM_GetPage(PMSoundStart + (v))
#define	PM_GetSpritePage(v)	PM_GetPage(PMSpriteStart + (v))

#define	PM_LockMainMem()	PM_SetMainMemPurge(0)
#define	PM_UnlockMainMem()	PM_SetMainMemPurge(3)

extern	char PageFileName[13];

extern void PM_Startup();
extern void PM_Shutdown();
extern void PM_Reset();
extern void PM_Preload(wbool (*update)(word current,word total));
extern void PM_NextFrame();
extern void PM_SetPageLock(int pagenum,PMLockType lock);
extern void PM_SetMainPurge(int level);
extern void PM_CheckMainMem();
extern memptr PM_GetPageAddress(int pagenum);
extern memptr PM_GetPage(int pagenum);		// Use this one to cache page

void PM_SetMainMemPurge(int level);
