//
//	ID Engine
//	ID_SD.h - Sound Manager Header
//	Version for Wolfenstein
//	By Jason Blochowiak
//

#ifndef	__ID_SD__
#define	__ID_SD__

void	alOut(byte n,byte b);

#ifdef	__DEBUG__
#define	__DEBUG_SoundMgr__
#endif

#define	TickBase	70	
	// 70Hz per tick - used as a base for timer 0

typedef	enum
{
	sdm_Off,
	sdm_PC,
	sdm_AdLib,
} SDMode;

typedef	enum
{
	smm_Off,
	smm_AdLib
} SMMode;

typedef	enum
{
	sds_Off,
	sds_PC,
	sds_SoundBlaster
} SDSMode;

typedef	struct
{
	longword	length;
	word		priority;
} SoundCommon;

// Global stuff
#define	alEffects	0xbd

typedef	struct
{
	byte	mChar,cChar,
			mScale,cScale,
			mAttack,cAttack,
			mSus,cSus,
			mWave,cWave,
			nConn,

			// These are only for Muse - these bytes are really unused
			voice,
			mode,
			unused[3];
} Instrument;

typedef	struct
{
	SoundCommon	common;
	Instrument	inst;
	byte		block,
				data[1];
} AdLibSound;
/*
//
//	Sequencing stuff
//
#define	sqMaxTracks	10
#define	sqMaxMoods	1	// DEBUG

#define	sev_Null		0	// Does nothing
#define	sev_NoteOff		1	// Turns a note off
#define	sev_NoteOn		2	// Turns a note on
#define	sev_NotePitch	3	// Sets the pitch of a currently playing note
#define	sev_NewInst		4	// Installs a new instrument
#define	sev_NewPerc		5	// Installs a new percussive instrument
#define	sev_PercOn		6	// Turns a percussive note on
#define	sev_PercOff		7	// Turns a percussive note off
#define	sev_SeqEnd		-1	// Terminates a sequence

// 	Flags for MusicGroup.flags
#define	sf_Melodic		0
#define	sf_Percussive	1
*/
typedef	struct
{
	word	length,
			values[1];
} MusicGroup;
/*
typedef	struct
		{
			// This part needs to be set up by the user
			word        mood, *moods[sqMaxMoods];

			// The rest is set up by the code
			Instrument	inst;
			wbool		percussive;
			word		*seq;
			longword	nextevent;
		} ActiveTrack;

#define	sqmode_Normal		0
#define	sqmode_FadeIn		1
#define	sqmode_FadeOut		2

#define	sqMaxFade		64	// DEBUG

*/
// Global variables
extern	wbool		AdLibPresent, SoundBlasterPresent,
					NeedsMusic,
				// For Caching Mgr
					SoundPositioned;
extern	SDMode		SoundMode;
extern	SDSMode		DigiMode;
extern	SMMode		MusicMode;
/*extern	wbool		DigiPlaying;
*/extern	int			DigiMap[];

extern longword		TicCount;
	// Global time in ticks

// Function prototypes
extern	void	SD_Startup(),
				SD_Shutdown(),

				SD_PositionSound(int leftvol,int rightvol);
extern	wbool	SD_PlaySound(soundnames sound);
extern	void	SD_SetPosition(int leftvol,int rightvol),
				SD_StopSound(),
				SD_WaitSoundDone(),

				SD_StartMusic(MusicGroup *music),
				SD_MusicOn(),
				SD_MusicOff(),
				SD_FadeOutMusic();

extern	wbool	SD_MusicPlaying(),
				SD_SetSoundMode(SDMode mode),
				SD_SetMusicMode(SMMode mode);
extern	word	SD_SoundPlaying();

extern	void	SD_SetDigiDevice(SDSMode),
				SD_PlayDigitized(word which,int leftpos,int rightpos),
				SD_StopDigitized(),
				SD_Poll();

#endif

