//
// WL_MENU.H
//

#ifdef SPEAR

#define BORDCOLOR	0x99
#define BORD2COLOR	0x93
#define DEACTIVE	0x9b
#define BKGDCOLOR	0x9d

#define MenuFadeOut(func)	GL_FadeOut(0,0,3*51,10,func)

#else

#define BORDCOLOR	0x29
#define BORD2COLOR	0x23
#define DEACTIVE	0x2b
#define BKGDCOLOR	0x2d
#define STRIPE		0x2c

#define MenuFadeOut(func)	GL_FadeOut(3*43,0,0,10,func)

#endif

#define READCOLOR	0x4a
#define READHCOLOR	0x47
#define VIEWCOLOR	0x7f
#define TEXTCOLOR	0x17
#define HIGHLIGHT	0x13
#define MenuFadeIn(func)	GL_FadeIn(3*43,0,0,10,func)


#define MENUSONG	WONDERIN_MUS

#ifndef SPEAR
#define INTROSONG	NAZI_NOR_MUS
#else
#define INTROSONG	XTOWER2_MUS
#endif

#define SENSITIVE	60
#define CENTER		SENSITIVE*2

#define MENU_X	76
#define MENU_Y	55
#define MENU_W	178
#ifndef SPEAR
#define MENU_H	13*10+6
#else
#define MENU_H	13*9+6
#endif

#define SM_X	48
#define SM_W	250

#define SM_Y1	20
#define SM_H1	4*13-7
#define SM_Y2	SM_Y1+5*13
#define SM_H2	4*13-7
#define SM_Y3	SM_Y2+5*13
#define SM_H3	3*13-7

#define CTL_X	24
#define CTL_Y	70
#define CTL_W	284
#define CTL_H	13*7-7

#define LSM_X	85
#define LSM_Y	55
#define LSM_W	175
#define LSM_H	10*13+10

#define NM_X	50
#define NM_Y	100
#define NM_W	225
#define NM_H	13*4+15

#define NE_X	10
#define NE_Y	23
#define NE_W	320-NE_X*2
#define NE_H	200-NE_Y*2

#define CST_X		20
#define CST_Y		48
#define CST_START	60
#define CST_SPC	60


//
// TYPEDEFS
//
typedef struct {
	int x,y,amount,curpos,indent;
} CP_iteminfo;

typedef struct {
	int active;
	char string[36];
	void (*routine)(int temp1);
} CP_itemtype;

typedef struct {
	int allowed[4];
} CustomCtrls;

extern CP_itemtype MainMenu[], NewEMenu[];
extern CP_iteminfo MainItems;

//
// FUNCTION PROTOTYPES
//
void SetupControlPanel();
void CleanupControlPanel();

void DrawMenu(CP_iteminfo *item_i,CP_itemtype *items);
int  HandleMenu(CP_iteminfo *item_i, CP_itemtype *items, void (*routine)(int w), void (*draw)());

void ClearMScreen();
void DrawWindow(int x,int y,int w,int h,int wcolor);
void DrawOutline(int x,int y,int w,int h,int color1,int color2);
void WaitKeyUp();
void ReadAnyControl(ControlInfo *ci);
void TicDelay(int count);
void CacheTextures(int lumpstart, int lumpend);
void UnCacheTextures(int lumpstart, int lumpend);
void StartCPMusic(int song);
/*int  Confirm(char *string);
void Message(char *string);
*/void CheckPause();
void ShootSnd();
void BossKey(void);

void ChangeTextColor(CP_itemtype *items,int hlight);
void DrawStripes(int y);

void DefineMouseBtns();
void DefineJoyBtns();
void DefineKeyBtns();
void DefineKeyMove();
void EnterCtrlData(int index,CustomCtrls *cust,void (*DrawRtn)(int),void (*PrintRtn)(int),int type);

void DrawMainMenu();
void DrawSoundMenu();
void DrawLoadSaveScreen();
void DrawNewEpisode();
void DrawNewGame();
void DrawChangeView();
void DrawMouseSens();
void DrawCtlScreen();
void DrawCustomScreen();
/*void DrawLSAction(int which);
*/void DrawCustMouse(int hilight);
void DrawCustJoy(int hilight);
void DrawCustKeybd(int hilight);
void DrawCustKeys(int hilight);
void PrintCustMouse(int i);
void PrintCustJoy(int i);
void PrintCustKeybd(int i);
void PrintCustKeys(int i);

void PrintLSEntry(int w,int color);
void TrackWhichGame(int w);
void FixupCustom(int w);

void CP_NewGame();
void CP_Sound();
int  CP_LoadGame(int quick);
int  CP_SaveGame(int quick);
void CP_Control();
void CP_ChangeView();
void CP_ExitOptions();
void CP_Quit();
void CP_ViewScores();
int  CP_EndGame();
int  CP_CheckQuick(unsigned short scancode);
void CustomControls();
void MouseSensitivity();

void CheckForEpisodes();

//
// VARIABLES
//
extern int SaveGamesAvail[10],StartGame,SoundStatus;
extern char SaveGameNames[10][32],SaveName[13];

enum {MOUSE,JOYSTICK,KEYBOARDBTNS,KEYBOARDMOVE};	// FOR INPUT TYPES

enum
{
	newgame,
	soundmenu,
	control,
	loadgame,
	savegame,
	changeview,

#ifndef GOODTIMES
#ifndef SPEAR
	readthis,
#endif
#endif

	viewscores,
	backtodemo,
	quit
} menuitems;

typedef struct
{
	unsigned long tex;
	float coords[256][4]; // l,r,t,b
} glfont;

extern glfont fonts[2];

//
// WL_INTER
//
typedef struct
{
	short kill, secret, treasure;
	long time;
} LRstruct;

extern LRstruct LevelRatios[];

void PG13();

void Write (int x,int y,char *string);

void NonShareware();
/*int GetYorN(int x,int y,int pic);
*/